var fontEnumerator = null;
var nickname = '';

function onPrefsLoad() {
  var count = { value: 0 }
  var fonts = getFontEnumerator().EnumerateAllFonts(count);
  var fontList = document.getElementById("fontpicker").firstChild;
  for (var font in fonts) {
    font = fonts[font];
    var itemNode = document.createElement("menuitem");
    itemNode.setAttribute("value", font);
    itemNode.setAttribute("label", font);
    fontList.appendChild(itemNode);
  }
  nickname = winMediator.getMostRecentWindow("msnmsgr:contact-list").getNickname();
  document.getElementById("txtNickname").value = nickname;
  document.getElementById("chkEmoticons").checked = getPref("getBoolPref", "show-emoticons", true);
  document.getElementById("chkRouter").checked = getPref("getBoolPref", "behind-router", false);
  document.getElementById("fontpicker").value = getPref("getCharPref", "font.name", "Arial");
  document.getElementById("foregroundtextmenu").color = getPref("getCharPref", "font.color", "#000000");
  document.getElementById("chkBold").checked = getPref("getBoolPref", "font.bold", false);
  document.getElementById("chkItalic").checked = getPref("getBoolPref", "font.italic", false);
  document.getElementById("chkUnderline").checked = getPref("getBoolPref", "font.underline", false);
  document.getElementById("chkStrike").checked = getPref("getBoolPref", "font.strike", false);
}

function doOK() {
  var newNickname = document.getElementById("txtNickname").value;
  if (newNickname != nickname) {
    winMediator.getMostRecentWindow("msnmsgr:contact-list").setNickname(newNickname);
  }
  prefBranch.setBoolPref("show-emoticons", document.getElementById("chkEmoticons").checked);
  prefBranch.setBoolPref("behind-router", document.getElementById("chkRouter").checked);
  prefBranch.setCharPref("font.name", document.getElementById("fontpicker").value);
  prefBranch.setBoolPref("font.bold", document.getElementById("chkBold").checked);
  prefBranch.setBoolPref("font.italic", document.getElementById("chkItalic").checked);
  prefBranch.setBoolPref("font.underline", document.getElementById("chkUnderline").checked);
  prefBranch.setBoolPref("font.strike", document.getElementById("chkStrike").checked);
  prefBranch.setCharPref("font.color", document.getElementById("foregroundtextmenu").color);
}

function getFontEnumerator() {
  if (fontEnumerator == null) {
    fontEnumerator = Components.classes["@mozilla.org/gfx/fontenumerator;1"].createInstance().QueryInterface(Components.interfaces.nsIFontEnumerator);
  }
  return fontEnumerator;
}